#version 330 core

in vec3 vertexColor;    //输入颜色数据
in vec2 TexCoord;       //输入纹理坐标数据

out vec4 FragColor;     //输出颜色数据

uniform sampler2D textureY; //Y分量纹理采样器
uniform sampler2D textureU; //U分量纹理采样器
uniform sampler2D textureV;

void main()
{
    //在着色器里取出某个位置上的像素值，rgba四分量，单通道只有r有效
    //y的范围是[0, 1]，u和v的范围是[-0.5, 0.5]
    float y = texture(textureY, TexCoord).r;
    //uv只有y分量的四分之一，映射到屏幕上的范围是[-0.5-0.5]，所以需要减去0.5
    float u = texture(textureU, TexCoord).r - 0.5;
    float v = texture(textureV, TexCoord).r - 0.5;
    float r = y + 1.402 * v;
    float g = y - 0.344136 * u - 0.714136 * v;
    float b = y + 1.772 * u;
    FragColor = vec4(r, g, b, 1.0);
}
